﻿Imports System.Web.Mvc
Imports HowDoICodeFirst.FluentRelationships.Models

Namespace HowDoICodeFirst.FluentRelationships.Controllers
	Public Class BlogController
		Inherits Controller
	  Private db As New BlogContext()

		Public Function Index() As ActionResult
			Return View(db.Blogs)
		End Function

		Public Function Create() As ActionResult
			Return View()
		End Function

		<HttpPost>
		Public Function Create(ByVal blog As Blog) As ActionResult
			Try
				db.Blogs.Add(blog)
				db.SaveChanges()

				Return RedirectToAction("Index")
			Catch
				Return View()
			End Try
		End Function

		Public Function Edit(ByVal id As Integer) As ActionResult


			Return View(db.Blogs.Find(id)) 'Find is a DbSet method, finds primary key
		End Function


		<HttpPost>
		Public Function Edit(ByVal id As Integer, ByVal blog As Blog) As ActionResult
			Try
				db.Entry(blog).State = EntityState.Modified
				db.SaveChanges()
				Return RedirectToAction("Index")
			Catch
				Return View()
			End Try
		End Function

		Public Function Delete(ByVal id As Integer) As ActionResult
		  Return View(db.Blogs.Find(id))
		End Function

		<HttpPost>
		Public Function Delete(ByVal id As Integer, ByVal blog As Blog) As ActionResult
			Try
				db.Entry(blog).State = EntityState.Deleted
				db.SaveChanges()

				Return RedirectToAction("Index")
			Catch
				Return View()
			End Try
		End Function
	End Class
End Namespace
